# Copyright 2013 Jeffrey Kegler
# This file is part of Marpa::R2.  Marpa::R2 is free software: you can
# redistribute it and/or modify it under the terms of the GNU Lesser
# General Public License as published by the Free Software Foundation,
# either version 3 of the License, or (at your option) any later version.
#
# Marpa::R2 is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser
# General Public License along with Marpa::R2.  If not, see
# http://www.gnu.org/licenses/.

# DO NOT EDIT THIS FILE DIRECTLY
# It was generated by make_internal_pm.pl

package Marpa::R2::Internal;

use 5.010;
use strict;
use warnings;
use Carp;

use vars qw($VERSION $STRING_VERSION);
$VERSION        = '2.065_004';
$STRING_VERSION = $VERSION;
$VERSION = eval $VERSION;


package Marpa::R2::Internal::Symbol;
constant->import( 'ID' => 0 );
constant->import( 'BLESSING' => 1 );
constant->import( 'LEXEME_SEMANTICS' => 2 );

package Marpa::R2::Internal::Rule;
constant->import( 'ID' => 0 );
constant->import( 'NAME' => 1 );
constant->import( 'DISCARD_SEPARATION' => 2 );
constant->import( 'MASK' => 3 );
constant->import( 'ACTION_NAME' => 4 );
constant->import( 'BLESSING' => 5 );

package Marpa::R2::Internal::Grammar;
constant->import( 'C' => 0 );
constant->import( 'TRACER' => 1 );
constant->import( 'RULES' => 2 );
constant->import( 'SYMBOLS' => 3 );
constant->import( 'ACTIONS' => 4 );
constant->import( 'BLESS_PACKAGE' => 5 );
constant->import( 'DEFAULT_ACTION' => 6 );
constant->import( 'TRACE_FILE_HANDLE' => 7 );
constant->import( 'WARNINGS' => 8 );
constant->import( 'RULE_NAME_REQUIRED' => 9 );
constant->import( 'RULE_BY_NAME' => 10 );
constant->import( 'INTERFACE' => 11 );
constant->import( 'INTERNAL' => 12 );
constant->import( 'CHARACTER_CLASSES' => 13 );
constant->import( 'CHARACTER_CLASS_TABLE' => 14 );
constant->import( 'LAST_BASIC_DATA_FIELD' => 14 );
constant->import( 'DEFAULT_EMPTY_ACTION' => 15 );
constant->import( 'ACTION_OBJECT' => 16 );
constant->import( 'INFINITE_ACTION' => 17 );
constant->import( 'LAST_EVALUATOR_FIELD' => 17 );
constant->import( 'PROBLEMS' => 18 );
constant->import( 'LAST_RECOGNIZER_FIELD' => 18 );
constant->import( 'START_NAME' => 19 );
constant->import( 'INACCESSIBLE_OK' => 20 );
constant->import( 'UNPRODUCTIVE_OK' => 21 );
constant->import( 'TRACE_RULES' => 22 );
constant->import( 'LAST_FIELD' => 22 );

package Marpa::R2::Internal::Recognizer;
constant->import( 'C' => 0 );
constant->import( 'B_C' => 1 );
constant->import( 'O_C' => 2 );
constant->import( 'T_C' => 3 );
constant->import( 'GRAMMAR' => 4 );
constant->import( 'FINISHED' => 5 );
constant->import( 'TOKEN_VALUES' => 6 );
constant->import( 'SLR' => 7 );
constant->import( 'ASF_OR_NODES' => 8 );
constant->import( 'TRACE_FILE_HANDLE' => 9 );
constant->import( 'END_OF_PARSE' => 10 );
constant->import( 'CLOSURES' => 11 );
constant->import( 'EVENT_IF_EXPECTED' => 12 );
constant->import( 'MAX_PARSES' => 13 );
constant->import( 'RANKING_METHOD' => 14 );
constant->import( 'TRACE_ACTIONS' => 15 );
constant->import( 'TRACE_AND_NODES' => 16 );
constant->import( 'TRACE_BOCAGE' => 17 );
constant->import( 'TRACE_EARLEY_SETS' => 18 );
constant->import( 'TRACE_OR_NODES' => 19 );
constant->import( 'TRACE_TASKS' => 20 );
constant->import( 'TRACE_TERMINALS' => 21 );
constant->import( 'TRACE_VALUES' => 22 );
constant->import( 'TRACE_SL' => 23 );
constant->import( 'WARNINGS' => 24 );
constant->import( 'RULE_RESOLUTIONS' => 25 );
constant->import( 'SYMBOL_RESOLUTIONS' => 26 );
constant->import( 'NULL_VALUES' => 27 );
constant->import( 'EVENTS' => 28 );
constant->import( 'READ_STRING_ERROR' => 29 );

package Marpa::R2::Internal::Progress_Report;
constant->import( 'RULE_ID' => 0 );
constant->import( 'POSITION' => 1 );
constant->import( 'ORIGIN' => 2 );
constant->import( 'CURRENT' => 3 );

package Marpa::R2::Internal::Scanless::Choicepoint;
constant->import( 'OR_NODE_IDS' => 0 );
constant->import( 'TOKEN_IDS' => 1 );
constant->import( 'EXTERNAL' => 2 );

package Marpa::R2::Internal::Scanless::ASF;
constant->import( 'SLR' => 0 );
constant->import( 'CHOICE_BLESSING' => 1 );
constant->import( 'RULE_BLESSING' => 2 );
constant->import( 'SYMBOL_BLESSING' => 3 );
constant->import( 'CHOICEPOINT_IS_FACTORED' => 4 );
constant->import( 'FAC_CHAF_PREDECESSOR_BY_CAUSE' => 5 );
constant->import( 'FAC_CHAF_CAUSE_IS_ACTIVE' => 6 );
constant->import( 'CHOICEPOINTS_BY_TOKEN_ID' => 7 );
constant->import( 'CHOICEPOINTS_BY_OR_NODE_ID' => 8 );

package Marpa::R2::Inner::Scanless::G;
constant->import( 'C' => 0 );
constant->import( 'THICK_LEX_GRAMMAR' => 1 );
constant->import( 'THICK_G1_GRAMMAR' => 2 );
constant->import( 'CHARACTER_CLASS_TABLE' => 3 );
constant->import( 'G0_RULE_TO_G1_LEXEME' => 4 );
constant->import( 'G0_DISCARD_SYMBOL_ID' => 5 );
constant->import( 'MASK_BY_RULE_ID' => 6 );
constant->import( 'G1_ARGS' => 7 );
constant->import( 'COMPLETION_EVENT_BY_ID' => 8 );
constant->import( 'NULLED_EVENT_BY_ID' => 9 );
constant->import( 'PREDICTION_EVENT_BY_ID' => 10 );
constant->import( 'LEXEME_EVENT_BY_ID' => 11 );
constant->import( 'TRACE_FILE_HANDLE' => 12 );
constant->import( 'BLESS_PACKAGE' => 13 );
constant->import( 'SYMBOL_IDS_BY_EVENT_NAME_AND_TYPE' => 14 );
constant->import( 'CACHE_RULEIDS_BY_LHS_NAME' => 15 );

package Marpa::R2::Inner::Scanless::R;
constant->import( 'C' => 0 );
constant->import( 'GRAMMAR' => 1 );
constant->import( 'THICK_G1_RECCE' => 2 );
constant->import( 'P_INPUT_STRING' => 3 );
constant->import( 'TRACE_FILE_HANDLE' => 4 );
constant->import( 'TRACE_G0' => 5 );
constant->import( 'TRACE_TERMINALS' => 6 );
constant->import( 'READ_STRING_ERROR' => 7 );
constant->import( 'EVENTS' => 8 );

1;
